using System;
using System.IO;
using System.Diagnostics;

class FibExample {

  int fibonacci(int n) {
    Debug.WriteLine("Entering fibonacci, n="+n);
    Debug.Indent();
    Debug.Assert(n>=0,
      "argument for fibonacci cannot be negative");
    int result;
    if (n < 2)
      result = 1;
    else
      result = fibonacci(n-1) + fibonacci(n-2);
    Debug.Unindent();
    Debug.WriteLine("Exiting fibonacci, result="+result);
    return result;
  }

  void Go() {
    Debug.WriteLine("Entering Go");
    Console.WriteLine("Fibonacci(4) = {0}", fibonacci(4));
    Console.WriteLine("Fibonacci(-1) = {0}", fibonacci(-1));
    Debug.WriteLine("Exiting Go");
  }

  static void Main() {
    Debug.Listeners.Clear();
    Debug.Listeners.Add(
        new TextWriterTraceListener("trace.txt"));
    Debug.AutoFlush = true;
    new FibExample().Go();
  }
}
